// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO168/16aio168_Linux_2.x.x.x_DN/driver/16aio168.h $
// $Rev: 53667 $
// $Date: 2023-08-31 16:09:35 -0500 (Thu, 31 Aug 2023) $

// 16AIO168: Device Driver: header file

#ifndef	__16AIO168_H__
#define	__16AIO168_H__

#include "gsc_common.h"
#include "gsc_pci9080.h"



// macros *********************************************************************

#define	AIO168_BASE_NAME					"16aio168"

// IOCTL command codes
#define	AIO168_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	AIO168_IOCTL_REG_WRITE				OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	AIO168_IOCTL_REG_MOD				OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	AIO168_IOCTL_QUERY					OS_IOCTL_RW( 3,  4, s32)
#define	AIO168_IOCTL_INITIALIZE				OS_IOCTL   ( 4)
#define	AIO168_IOCTL_AUTOCAL				OS_IOCTL   ( 5)
#define	AIO168_IOCTL_AUTOCAL_STATUS			OS_IOCTL_R ( 6,  4, s32)
#define	AIO168_IOCTL_AI_BUF_CLEAR			OS_IOCTL   ( 7)
#define	AIO168_IOCTL_AI_BUF_THR_LVL			OS_IOCTL_RW( 8,  4, s32)
#define	AIO168_IOCTL_AI_BUF_THR_STS			OS_IOCTL_R ( 9,  4, s32)
#define	AIO168_IOCTL_AI_MODE				OS_IOCTL_RW(10,  4, s32)
#define	AIO168_IOCTL_AI_SCAN_1_CHAN			OS_IOCTL_RW(11,  4, s32)
#define	AIO168_IOCTL_AI_SCAN_CLK_SRC		OS_IOCTL_RW(12,  4, s32)
#define	AIO168_IOCTL_AI_SCAN_SIZE			OS_IOCTL_RW(13,  4, s32)
#define	AIO168_IOCTL_AI_SYNC				OS_IOCTL   (14)
#define	AIO168_IOCTL_AO_BUF_CLEAR			OS_IOCTL   (15)
#define	AIO168_IOCTL_AO_BUF_THR_LVL			OS_IOCTL_RW(16,  4, s32)
#define	AIO168_IOCTL_AO_BUF_THR_STS			OS_IOCTL_RW(17,  4, s32)
#define	AIO168_IOCTL_AO_BURST_CLK_SRC		OS_IOCTL_RW(18,  4, s32)
#define	AIO168_IOCTL_AO_BURST_ENABLE		OS_IOCTL_RW(19,  4, s32)
#define	AIO168_IOCTL_AO_CLK_SRC				OS_IOCTL_RW(20,  4, s32)
#define	AIO168_IOCTL_AO_LOOPING				OS_IOCTL_RW(21,  4, s32)
#define	AIO168_IOCTL_AO_SYNC				OS_IOCTL   (22)
#define	AIO168_IOCTL_AO_TIMING				OS_IOCTL_RW(23,  4, s32)
#define	AIO168_IOCTL_DATA_FORMAT			OS_IOCTL_RW(24,  4, s32)
#define	AIO168_IOCTL_DIO_WRITE				OS_IOCTL_RW(25,  4, s32)
#define	AIO168_IOCTL_EXT_SYNC_SRC			OS_IOCTL_RW(26,  4, s32)
#define	AIO168_IOCTL_IRQ0_SEL				OS_IOCTL_RW(27,  4, s32)
#define	AIO168_IOCTL_IRQ1_SEL				OS_IOCTL_RW(28,  4, s32)
#define	AIO168_IOCTL_IRQ2_SEL				OS_IOCTL_RW(29,  4, s32)
#define	AIO168_IOCTL_RAG_ENABLE				OS_IOCTL_RW(30,  4, s32)
#define	AIO168_IOCTL_RAG_NRATE				OS_IOCTL_RW(31,  4, s32)
#define	AIO168_IOCTL_RANGE					OS_IOCTL_RW(32,  4, s32)
#define	AIO168_IOCTL_RBG_CLK_SRC			OS_IOCTL_RW(33,  4, s32)
#define	AIO168_IOCTL_RBG_ENABLE				OS_IOCTL_RW(34,  4, s32)
#define	AIO168_IOCTL_RBG_NRATE				OS_IOCTL_RW(35,  4, s32)
#define	AIO168_IOCTL_RX_IO_ABORT			OS_IOCTL_R (36,  4, s32)
#define	AIO168_IOCTL_RX_IO_MODE				OS_IOCTL_RW(37,  4, s32)
#define	AIO168_IOCTL_RX_IO_TIMEOUT			OS_IOCTL_RW(38,  4, s32)
#define	AIO168_IOCTL_TX_IO_ABORT			OS_IOCTL_R (39,  4, s32)
#define	AIO168_IOCTL_TX_IO_MODE				OS_IOCTL_RW(40,  4, s32)
#define	AIO168_IOCTL_TX_IO_TIMEOUT			OS_IOCTL_RW(41,  4, s32)
#define	AIO168_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(42, 28, gsc_wait_t)
#define	AIO168_IOCTL_WAIT_EVENT				OS_IOCTL_RW(43, 28, gsc_wait_t)
#define	AIO168_IOCTL_WAIT_STATUS			OS_IOCTL_RW(44, 28, gsc_wait_t)

//*****************************************************************************
// AIO168_IOCTL_REG_READ
// AIO168_IOCTL_REG_WRITE
// AIO168_IOCTL_REG_MOD
//
#define	AIO168_REG_ENCODE(s,o)				GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AIO168_GSC_BCR						AIO168_REG_ENCODE(4,0x00)// Board Control Register
#define	AIO168_GSC_ICR						AIO168_REG_ENCODE(4,0x04)// Interrupt Control Register
#define	AIO168_GSC_IDBR						AIO168_REG_ENCODE(4,0x08)// Input Data Buffer Register
#define	AIO168_GSC_IBCR						AIO168_REG_ENCODE(4,0x0C)// Input Buffer Control Register
#define	AIO168_GSC_RAGR						AIO168_REG_ENCODE(4,0x10)// Rate-A Generator Register
#define	AIO168_GSC_RBGR						AIO168_REG_ENCODE(4,0x14)// Rate-B Generator Register
#define	AIO168_GSC_ODBR						AIO168_REG_ENCODE(4,0x18)// Output Data Buffer Register
#define	AIO168_GSC_OBCR						AIO168_REG_ENCODE(4,0x1C)// Output Buffer Control Register
#define	AIO168_GSC_SSCR						AIO168_REG_ENCODE(4,0x20)// Scan and Sync Control Register
#define	AIO168_GSC_DOCR						AIO168_REG_ENCODE(4,0x24)// Digital Output Control Register
#define	AIO168_GSC_FRR						AIO168_REG_ENCODE(4,0x28)// Firmware Revision Register
#define	AIO168_GSC_AVR						AIO168_REG_ENCODE(4,0x2C)// Auto Cal Values Register

//*****************************************************************************
// AIO168_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	AIO168_QUERY_AUTOCAL_MS,	// Max autocalibrate period in ms.
	AIO168_QUERY_CHAN_AI_MAX,	// The number of Analog Input channels.
	AIO168_QUERY_CHAN_AO_MAX,	// The maximum number of Analog Output channels.
	AIO168_QUERY_COUNT,			// How many query options are supported?
	AIO168_QUERY_DEVICE_TYPE,	// Value from gsc_dev_type_t
	AIO168_QUERY_FGEN_MAX,		// Rate Generator maximum rate.
	AIO168_QUERY_FGEN_MIN,		// Rate Generator minimum rate.
	AIO168_QUERY_FIFO_SIZE_RX,	// Rx FIFO depth in 32-bit samples
	AIO168_QUERY_FIFO_SIZE_TX,	// Tx FIFO depth in 32-bit samples
	AIO168_QUERY_FREF_DEFAULT,	// The default master clock frequency.
	AIO168_QUERY_FSAMP_MAX,		// The maximum sample rate.
	AIO168_QUERY_FSAMP_MIN,		// The minimum sample rate.
	AIO168_QUERY_INIT_MS,		// Max initialize period in ms.
	AIO168_QUERY_NRATE_MAX,		// Maximum rate generator Nrate value.
	AIO168_QUERY_NRATE_MIN,		// Maximum rate generator Nrate value.
	AIO168_IOCTL_QUERY_LAST		// This one MUST be last.

} aio168_query_t;

#define	AIO168_IOCTL_QUERY_ERROR			(-1)

// Retained for backwards compatibility only:
#define	AIO168_QUERY_AUTO_CAL_MS			AIO168_QUERY_AUTOCAL_MS

//*****************************************************************************
// AIO168_IOCTL_INITIALIZE					BCR D15
//
//	Parameter:	None

//*****************************************************************************
// AIO168_IOCTL_AUTOCAL						BCR D13-D14
//
//	Parameter:	None

// Retained for backwards compatibility only:
#define	AIO168_IOCTL_AUTO_CALIBRATE			AIO168_IOCTL_AUTOCAL

//*****************************************************************************
// AIO168_IOCTL_AUTOCAL_STATUS				BCR D14
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AIO168_AUTOCAL_STATUS_ACTIVE		0
#define	AIO168_AUTOCAL_STATUS_FAIL			1
#define	AIO168_AUTOCAL_STATUS_PASS			2

// Retained for backwards compatibility only:
#define	AIO168_IOCTL_AUTO_CAL_STS			AIO168_IOCTL_AUTOCAL_STATUS
#define	AIO168_AUTO_CAL_STS_ACTIVE			AIO168_AUTOCAL_STATUS_ACTIVE
#define	AIO168_AUTO_CAL_STS_FAIL			AIO168_AUTOCAL_STATUS_FAIL
#define	AIO168_AUTO_CAL_STS_PASS			AIO168_AUTOCAL_STATUS_PASS

//*****************************************************************************
// AIO168_IOCTL_AI_BUF_CLEAR				IBCR D15
//
//	Parameter:	None.

//*****************************************************************************
// AIO168_IOCTL_AI_BUF_THR_LVL				IBCR D0-D14
//
//	Parameter:	s32*
//		Pass in any valid value from 0x0 to 0x7FFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AIO168_IOCTL_AI_BUF_THR_STS				IBCR D16
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AIO168_AI_BUF_THR_STS_CLEAR			0
#define	AIO168_AI_BUF_THR_STS_SET			1

//*****************************************************************************
// AIO168_IOCTL_AI_MODE						BCR D0-D3
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_AI_MODE_DIFF					0	// Differential
#define	AIO168_AI_MODE_SINGLE				1	// Single-Ended
#define	AIO168_AI_MODE_ZERO					2	// Zero test
#define	AIO168_AI_MODE_VREF					3	// Vref test
#define	AIO168_AI_MODE_AO_0					4	// Analog Output Channel 0
#define	AIO168_AI_MODE_AO_1					5	// Analog Output Channel 1
#define	AIO168_AI_MODE_AO_2					6	// Analog Output Channel 2
#define	AIO168_AI_MODE_AO_3					7	// Analog Output Channel 3
#define	AIO168_AI_MODE_AO_4					8	// Analog Output Channel 4
#define	AIO168_AI_MODE_AO_5					9	// Analog Output Channel 5
#define	AIO168_AI_MODE_AO_6					10	// Analog Output Channel 6
#define	AIO168_AI_MODE_AO_7					11	// Analog Output Channel 7

//*****************************************************************************
// AIO168_IOCTL_AI_SCAN_1_CHAN				SSCR D12-D16
//
//	Parameter:	s32*
//		Pass in any valid value from 0 to 15, or
//		-1 to read the current setting.

//*****************************************************************************
// AIO168_IOCTL_AI_SCAN_CLK_SRC				SSCR D2-D3
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_AI_SCAN_CLK_SRC_RAG			0	// Rate-A Generator
#define	AIO168_AI_SCAN_CLK_SRC_RBG			1	// Rate-B Generator
#define	AIO168_AI_SCAN_CLK_SRC_EXT			2	// External Sync Input signal
#define	AIO168_AI_SCAN_CLK_SRC_BCR			3	// BCR D12

//*****************************************************************************
// AIO168_IOCTL_AI_SCAN_SIZE				SSCR D0-D1,D11,D17
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_AI_SCAN_SIZE_SINGLE			0
#define	AIO168_AI_SCAN_SIZE_0_1				1
#define	AIO168_AI_SCAN_SIZE_0_3				2
#define	AIO168_AI_SCAN_SIZE_0_7				3
#define	AIO168_AI_SCAN_SIZE_0_15			4	// Single Ended mode only

//*****************************************************************************
// AIO168_IOCTL_AI_SYNC						BCR D12
//
//	Parameter:	None

//*****************************************************************************
// AIO168_IOCTL_AO_BUF_CLEAR				OBCR D15
//
//	Parameter:	None.

//*****************************************************************************
// AIO168_IOCTL_AO_BUF_THR_LVL				OBCR D0-D14
//
//	Parameter:	s32*
//		Pass in any valid value from 0x0 to 0x7FFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AIO168_IOCTL_AO_BUF_THR_STS				OBCR D16
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AIO168_AO_BUF_THR_STS_CLEAR			0
#define	AIO168_AO_BUF_THR_STS_SET			1

//*****************************************************************************
// AIO168_IOCTL_AO_BURST_CLK_SRC			SSCR D6-D7
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AIO168_AO_BURST_CLK_SRC_RAG			0
#define	AIO168_AO_BURST_CLK_SRC_RBG			1
#define	AIO168_AO_BURST_CLK_SRC_EXT			2
#define	AIO168_AO_BURST_CLK_SRC_BCR			3

//*****************************************************************************
// AIO168_IOCTL_AO_BURST_ENABLE				BCR D9
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AIO168_AO_BURST_ENABLE_NO			0
#define	AIO168_AO_BURST_ENABLE_YES			1

//*****************************************************************************
// AIO168_IOCTL_AO_CLK_SRC					SSCR D4-D5
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AIO168_AO_CLK_SRC_RAG				0
#define	AIO168_AO_CLK_SRC_RBG				1
#define	AIO168_AO_CLK_SRC_EXT				2
#define	AIO168_AO_CLK_SRC_DISABLE			3

//*****************************************************************************
// AIO168_IOCTL_AO_LOOPING					BCR D10
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AIO168_AO_LOOPING_DISABLE			0
#define	AIO168_AO_LOOPING_ENABLE			1

//*****************************************************************************
// AIO168_IOCTL_AO_SYNC						BCR D11
//
//	Parameter:	None

//*****************************************************************************
// AIO168_IOCTL_AO_TIMING					BCR D8
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	AIO168_AO_TIMING_SEQ				0
#define	AIO168_AO_TIMING_SIMUL				1

//*****************************************************************************
// AIO168_IOCTL_DATA_FORMAT					BCR D6
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_DATA_FORMAT_2S_COMP			0	// Twos Compliment
#define	AIO168_DATA_FORMAT_OFF_BIN			1	// Offset Binary

//*****************************************************************************
// AIO168_IOCTL_DIO_WRITE					DOCR D0-D3
//
//	Parameter:	s32*
//		Pass in any value in the range of 0 to 0xF, or
//		-1 to read the current setting.
//		The value returned in the value read.

//*****************************************************************************
// AIO168_IOCTL_EXT_SYNC_SRC				SSCR D8-D9
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_AI_EXT_SYNC_SRC_AISC			0	// Analog Input Scan Clock
#define	AIO168_AI_EXT_SYNC_SRC_AOS			1	// Analog Output Sync Clock
#define	AIO168_AI_EXT_SYNC_SRC_EXT			2	// External Sync Input signal
#define	AIO168_AI_EXT_SYNC_SRC_DISABLE		3

//*****************************************************************************
// AIO168_IOCTL_IRQ0_SEL					ICR D0-D2
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting. The value -1 cal be passed in for the
//		SEL service to determine which option is selected.
#define	AIO168_IRQ0_IDLE_INIT				0
#define	AIO168_IRQ0_AUTOCAL_DONE			1


// Retained for backwards compatibility only:
#define	AIO168_IRQ0_AUTO_CAL_DONE			AIO168_IRQ0_AUTOCAL_DONE

//*****************************************************************************
// AIO168_IOCTL_IRQ1_SEL					ICR D4-D6
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting. The value -1 cal be passed in for the
//		SEL service to determine which option is selected.
#define	AIO168_IRQ1_IDLE					0
#define	AIO168_IRQ1_AI_BUF_THR_L2H			1
#define	AIO168_IRQ1_AI_BUF_THR_H2L			2

//*****************************************************************************
// AIO168_IOCTL_IRQ2_SEL					ICR D8-10
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting. The value -1 cal be passed in for the
//		SEL service to determine which option is selected.
#define	AIO168_IRQ2_IDLE					0
#define	AIO168_IRQ2_AO_BUF_THR_L2H			1
#define	AIO168_IRQ2_AO_BUF_THR_H2L			2
#define	AIO168_IRQ2_AO_BURST_DONE			3

//*****************************************************************************
// AIO168_IOCTL_RAG_ENABLE					RAGR D16
// AIO168_IOCTL_RBG_ENABLE					RBGR D16
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_GEN_ENABLE_NO				1
#define	AIO168_GEN_ENABLE_YES				0

//*****************************************************************************
// AIO168_IOCTL_RAG_NRATE					RAGR D0-D15
// AIO168_IOCTL_RBG_NRATE					RBGR D0-D15
//
//	Parameter:	s32*
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		At this time the valid range is 100-0xFFFF.

//*****************************************************************************
// AIO168_IOCTL_RANGE						BCR D4-D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_RANGE_2_5V					0	// +- 2.5 volts
#define	AIO168_RANGE_5V						1	// +- 5 volts
#define	AIO168_RANGE_10V					2	// +- 10 volts

//*****************************************************************************
// AIO168_IOCTL_RBG_CLK_SRC					SSCR D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AIO168_RBG_CLK_SRC_MASTER			0
#define	AIO168_RBG_CLK_SRC_RAG				1

//*****************************************************************************
// AIO168_IOCTL_RX_IO_ABORT
// AIO168_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AIO168_IO_ABORT_NO					0
#define	AIO168_IO_ABORT_YES					1

//*****************************************************************************
// AIO168_IOCTL_RX_IO_MODE
// AIO168_IOCTL_TX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AIO168_IO_MODE_DEFAULT				GSC_IO_MODE_PIO
// GSC_IO_MODE_BMDMA

//*****************************************************************************
// AIO168_IOCTL_RX_IO_TIMEOUT (in seconds)
// AIO168_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AIO168_IO_TIMEOUT_DEFAULT			10
#define	AIO168_IO_TIMEOUT_NO_SLEEP			0
#define	AIO168_IO_TIMEOUT_MIN				0
#define	AIO168_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	AIO168_IO_TIMEOUT_INFINITE			GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AIO168_IOCTL_WAIT_EVENT					all fields must be valid
// AIO168_IOCTL_WAIT_CANCEL					fields need not be valid
// AIO168_IOCTL_WAIT_STATUS					fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AIO168_WAIT_GSC_IDLE_INIT			0x0001
#define	AIO168_WAIT_GSC_AUTOCAL_DONE		0x0002
#define	AIO168_WAIT_GSC_AI_BUF_THR_L2H		0x0004
#define	AIO168_WAIT_GSC_AI_BUF_THR_H2L		0x0008
#define	AIO168_WAIT_GSC_AO_BUF_THR_L2H		0x0010
#define	AIO168_WAIT_GSC_AO_BUF_THR_H2L		0x0020
#define	AIO168_WAIT_GSC_AO_BURST_DONE		0x0040
#define	AIO168_WAIT_GSC_ALL					0x007F
// gsc_wait_t.alt flags
#define	AIO168_WAIT_ALT_ALL					0x0000
// gsc_wait_t.io
#define	AIO168_WAIT_IO_RX_ABORT				0x0001
#define	AIO168_WAIT_IO_RX_DONE				0x0002
#define	AIO168_WAIT_IO_RX_ERROR				0x0004
#define	AIO168_WAIT_IO_RX_TIMEOUT			0x0008

#define	AIO168_WAIT_IO_TX_ABORT				0x0010
#define	AIO168_WAIT_IO_TX_DONE				0x0020
#define	AIO168_WAIT_IO_TX_ERROR				0x0040
#define	AIO168_WAIT_IO_TX_TIMEOUT			0x0080

#define	AIO168_WAIT_IO_ALL					0x00FF

// Retained for backwards compatibility only:
#define	AIO168_WAIT_GSC_AUTO_CAL_DONE		AIO168_WAIT_GSC_AUTOCAL_DONE



#endif
