// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO168/16aio168_Linux_2.x.x.x_DN/include/16aio168_utils.h $
// $Rev: 53664 $
// $Date: 2023-08-31 16:01:18 -0500 (Thu, 31 Aug 2023) $

// 16AIO168: Utilities: header file

#ifndef	__16AIO168_UTILS_H__
#define	__16AIO168_UTILS_H__

#include "16aio168_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	aio168_close_util			(int fd, int index, int verbose);
int aio168_init_util			(int verbose);
int aio168_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	aio168_open_util			(int device, int share, int index, int verbose, int* fd);
int	aio168_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);
int	aio168_write_util			(int fd, int index, int verbose, const void* src, size_t bytes, size_t* sent);

// IOCTL utility services

int	aio168_ai_buf_clear			(int fd, int index, int verbose);								// AIO168_IOCTL_AI_BUF_CLEAR
int	aio168_ai_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AI_BUF_THR_LVL
int	aio168_ai_buf_thr_sts		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AI_BUF_THR_STS
int	aio168_ai_mode				(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AI_MODE
int	aio168_ai_scan_1_chan		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AI_SCAN_1_CHAN
int	aio168_ai_scan_clk_src		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AI_SCAN_CLK_SRC
int	aio168_ai_scan_size			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AI_SCAN_SIZE
int	aio168_ai_sync				(int fd, int index, int verbose);								// AIO168_IOCTL_AI_SYNC
int	aio168_ao_buf_clear			(int fd, int index, int verbose);								// AIO168_IOCTL_AO_BUF_CLEAR
int	aio168_ao_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AO_BUF_THR_LVL
int	aio168_ao_buf_thr_sts		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AO_BUF_THR_STS
int	aio168_ao_burst_clk_src		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AO_BURST_CLK_SRC
int	aio168_ao_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AO_BURST_ENABLE
int	aio168_ao_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AO_CLK_SRC
int	aio168_ao_looping			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AO_LOOPING
int	aio168_ao_sync				(int fd, int index, int verbose);								// AIO168_IOCTL_AO_SYNC
int	aio168_ao_timing			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_AO_TIMING
int	aio168_autocal				(int fd, int index, int verbose);								// AIO168_IOCTL_AUTOCAL
int	aio168_autocal_status		(int fd, int index, int verbose, s32* get);						// AIO168_IOCTL_AUTOCAL_STATUS
int	aio168_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_DATA_FORMAT
int	aio168_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_DIO_WRITE
int	aio168_ext_sync_src			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_EXT_SYNC_SRC
int	aio168_initialize			(int fd, int index, int verbose);								// AIO168_IOCTL_INITIALIZE
int	aio168_irq0_sel				(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_IRQ0_SEL
int	aio168_irq1_sel				(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_IRQ1_SEL
int	aio168_irq2_sel				(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_IRQ2_SEL
int	aio168_query				(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_QUERY
int	aio168_rag_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RAG_ENABLE
int	aio168_rag_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RAG_NRATE
int	aio168_rbg_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RBG_CLK_SRC
int	aio168_rbg_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RBG_ENABLE
int	aio168_rbg_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RBG_NRATE
int	aio168_range				(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RANGE
int	aio168_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AIO168_IOCTL_REG_MOD
int	aio168_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);			// AIO168_IOCTL_REG_READ
int	aio168_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AIO168_IOCTL_REG_WRITE
int	aio168_rx_io_abort			(int fd, int index, int verbose, s32* get);						// AIO168_IOCTL_RX_IO_ABORT
int	aio168_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RX_IO_MODE
int	aio168_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_RX_IO_TIMEOUT
int	aio168_tx_io_abort			(int fd, int index, int verbose, s32* get);						// AIO168_IOCTL_TX_IO_ABORT
int	aio168_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_TX_IO_MODE
int	aio168_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AIO168_IOCTL_TX_IO_TIMEOUT
int	aio168_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AIO168_IOCTL_WAIT_CANCEL
int	aio168_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AIO168_IOCTL_WAIT_EVENT
int	aio168_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AIO168_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	aio168_config_ai			(int fd, int index, int verbose, s32 fsamp);
int	aio168_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	aio168_fsamp_ai_compute		(int fd, int index, int verbose, s32 fsamp, s32* nrate, double* rate);
int aio168_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int aio168_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int	aio168_fsamp_ao_compute		(int fd, int index, int verbose, s32 fsamp, s32* nrate, double* rate);
int aio168_fsamp_ao_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int aio168_fsamp_ao_report_all	(int fd, int index, int verbose, s32* fsamp);
int	aio168_id_device			(int fd, int index, int verbose);

int	aio168_count_boards			(int verbose, s32* get);
int	aio168_fsamp_ai_get			(int fd, int chan, int title, int use, s32* get);
int	aio168_reg_list				(int fd, int detail);

const gsc_reg_def_t*			aio168_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*			aio168_reg_get_def_index	(int index);
const char*						aio168_reg_get_desc			(u32 reg);
const char*						aio168_reg_get_name			(u32 reg);

// Retained for backwards compatibility only:
int	aio168_auto_cal_sts			(int fd, int index, int verbose, s32* get);
int	aio168_auto_calibrate		(int fd, int index, int verbose);



#endif
