// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO168/16aio168_Linux_2.x.x.x_DN/samples/irq/irq0.c $
// $Rev: 53656 $
// $Date: 2023-08-31 15:54:04 -0500 (Thu, 31 Aug 2023) $

// 16AIO168: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _init(int fd)
{
	int	errs;
	int	ret;

	ret		= aio168_ioctl(fd, AIO168_IOCTL_INITIALIZE, NULL);
	errs	= ret ? 1 : 0;

	return(errs);
}



//*****************************************************************************
static int _irq0_initialize_test(int fd)
{
	int	errs;

	gsc_label("Initialize");
	errs	= irq_wait_test(fd, AIO168_WAIT_GSC_IDLE_INIT, _init);
	return(errs);
}



//*****************************************************************************
static int _autocal(int fd)
{
	int	errs;
	int	ret;

	ret		= aio168_ioctl(fd, AIO168_IOCTL_AUTOCAL, NULL);
	errs	= ret ? 1 : 0;
	return(errs);
}



//*****************************************************************************
static int _irq0_autocal_test(int fd)
{
	int	errs;

	gsc_label("Autocalibrate");
	errs	= irq_wait_test(fd, AIO168_WAIT_GSC_AUTOCAL_DONE, _autocal);
	return(errs);
}



//*****************************************************************************
int irq0_test(int fd)
{
	int	errs	= 0;

	gsc_label("IRQ0");
	printf("\n");
	gsc_label_level_inc();

	errs	+= _irq0_initialize_test(fd);
	errs	+= _irq0_autocal_test(fd);

	gsc_label_level_dec();
	return(errs);
}



